(function() {
  var Actor, Commit, Diff, Treeish, _,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  _ = require('../lodash');

  Actor = require('./actor');

  Diff = require('./diff');

  Treeish = require('./treeish');

  Commit = (function(superClass) {
    extend(Commit, superClass);

    function Commit(raw1, repo) {
      this.raw = raw1;
      this.repo = repo;
      if (!_.isString(this.raw)) {
        throw new Error('No raw data');
      }
      Commit.__super__.constructor.call(this, this.parseRef(this.raw), this.repo);
      this.parseRaw();
    }

    Commit.prototype.parseRaw = function() {
      var ref, ref1;
      if (this.ref == null) {
        this.ref = this.parseRef(this.raw);
      }
      this.tree = this.parseTree(this.raw);
      ref = this.actor(this.parseAuthor(this.raw)), this.author = ref[0], this.authoredDate = ref[1];
      ref1 = this.actor(this.parseCommitter(this.raw)), this.committer = ref1[0], this.committedDate = ref1[1];
      this.parents = this.parseParents(this.raw);
      this.gpgsig = this.parseGpgSig(this.raw);
      return this.message = this.parseMessage(this.raw);
    };

    Commit.prototype.parseRef = function(raw) {
      var regex;
      regex = /^(?:commit )?([a-z0-9]{40})$/m;
      return raw.match(regex)[1];
    };

    Commit.prototype.parseTree = function(raw) {
      var ref, regex;
      regex = /^tree\s(.+)$/m;
      return (ref = raw.match(regex)) != null ? ref[1] : void 0;
    };

    Commit.prototype.parseAuthor = function(raw) {
      var ref, regex;
      regex = /^author\s(.+)$/m;
      return (ref = raw.match(regex)) != null ? ref[1] : void 0;
    };

    Commit.prototype.parseCommitter = function(raw) {
      var ref, regex;
      regex = /^committer\s(.+)$/m;
      return (ref = raw.match(regex)) != null ? ref[1] : void 0;
    };

    Commit.prototype.parseParents = function(raw) {
      var i, len, parent, parents, ref, regex, results;
      regex = /^parent\s(.+)$/gm;
      parents = raw.match(regex) || [];
      results = [];
      for (i = 0, len = parents.length; i < len; i++) {
        parent = parents[i];
        results.push((ref = parent.split(' ')) != null ? ref[1] : void 0);
      }
      return results;
    };

    Commit.prototype.parseGpgSig = function(raw) {
      var ref, ref1, regex;
      regex = /^[^\-} | {VERSION} | {\n](.*)+$/gm;
      return (ref = raw.match(regex)) != null ? (ref1 = ref[1]) != null ? typeof ref1.join === "function" ? ref1.join('\n') : void 0 : void 0 : void 0;
    };

    Commit.prototype.parseMessage = function(raw) {
      var message, ref, regex;
      regex = /^[ ]{4}([^]*)$/gm;
      message = (ref = raw.match(regex)) != null ? ref[0] : void 0;
      return message != null ? message.replace(/^ {4}} | { +$/m, '').trim() : void 0;
    };

    Commit.prototype.actor = function(line) {
      var actor, epoch, m, ref;
      ref = (line != null ? line.match(/^(.*?) (\d+) .*$/m) : void 0) || ['', '', ''], m = ref[0], actor = ref[1], epoch = ref[2];
      return [new Actor(actor), new Date(1000 * +epoch)];
    };

    return Commit;

  })(Treeish);

  module.exports = Commit;

}).call(this);
